<?php

namespace VeryBuy\Payment\SinoPac\Exceptions;

use LogicException;

class FailedException extends LogicException
{
    protected $map = [
        'E10000' => '超過轉帳上限',
        'E11000' => '訂單編號重複',
        'E12000' => '繳款截止日設定範圍錯誤',
        'E13000' => '訂單金額格式錯誤',
        'E14000' => '付款狀態查詢條件錯誤',
        'E15000' => '日期或時間格式不正確',
        'E17000' => '訊息格式不正確',
        'E18000' => '會員編號不存在',
        'E19000' => '用戶訂單編號不得超過 50 個字元，不可空白，不可包含特殊字元',
        'E21000' => '商品描述長度不得超過 60 個中英文字，不可空白，不可包含特殊字元',
        'E22000' => '收款總額度不足',
        'E23000' => '訂單金額不得小於手續費金額',
        'E24000' => '信用卡授權失敗',
        'E24999' => '信用卡授權逾時',
        'E24998' => '信用卡連線錯誤',
        'E24997' => '信用卡分期付款及紅利折抵不得同時為 Y',
        'E24996' => '信用卡分期期數欄位格式錯誤',
        'E24995' => '信用卡分期期數欄位值錯誤',
        'E24994' => '非永豐銀行信用卡',
        'E24993' => '不支援分期付款功能',
        'E24992' => '不支援紅利折抵功能',
        'E24991' => '不合法的是否使用紅利折抵旗標格式',
        'E24990' => '不合法的是否使用分期款旗標格式',
        'E24989' => '不支援一次付清功能',
        'E24988' => '不支援銀聯卡功能',
        'E24987' => '不合法的是否使用銀聯卡旗標格式',
        'E25000' => '銀行系統維護中，虛擬帳號取號失敗',
        'E26000' => '該筆銀聯卡訂單已失效 ',
        'E27000' => '信用卡訂單維護要求無效',
        'E29000' => '用戶訂單編號不存在',
        'E30000' => '付款方式欄位值錯誤',
        'E31000' => '日期起迄日必須同時有值或無值',
        'E32000' => '查詢條件不足',
        'E33000' => '達到查詢次數上限 ',
        'E34000' => '查詢結果筆數過多，請調整查詢範圍',
        'E35000' => '撥款編號錯誤 ',
        'E36000' => '訊息簽章驗證失敗',
        'E38000' => '自動請款欄位值必須為 Y 或 N',
        'E50000' => '備註長度不得超過 30 個中英文字，不可包含特殊字元',
        'E51000' => '付款人地址不得超過 40 個中英文字，不可包含特殊字元',
        'E52000' => '付款人行動電話不得超過 10 個數字，不可包含非數字',
        'E53000' => '付款人姓名長度不得超過 20 個中英文字，不可包含特殊字元',
        'E54000' => '收貨人地址不得超過 40 個中英文字，不可包含特殊字元',
        'E55000' => '收貨人行動電話不得超過 10 個數字，不可包含非數字',
        'E56000' => '收貨人姓名長度不得超過 20 個中英文字，不可包含特殊字元',
        'E57000' => '收款額度不足',
        'E58000' => '收款服務帳戶待 Email 認証中',
        'E59000' => '收款服務帳戶已久未使用',
        'E60000' => '收款服務帳戶已解約',
        'E61000' => '收款服務帳戶已被暫停使用 ',
        'E62000' => '用戶無申請該種收款方式',
        'E63000' => '付款人 EMail 長度不得超過 255 個字',
        'E64000' => '收貨人 EMail 長度不得超過 255 個字',
        'E65000' => '超過可查詢的時間區間',
        'E67000' => '幣別代碼不合法',
        'E68000' => '信用卡交易維護 - 發送要求欄位值錯誤',
        'E69000' => '收款名稱旗標格式必須為 Y 或 N',
        'E70000' => '備註旗標格式必須為 Y 或 N',
        'E71000' => '付款人姓名旗標格式必須為 Y 或 N',
        'E72000' => '付款人行動電話旗標格式必須為 Y 或 N',
        'E73000' => '付款人電子郵件旗標格式必須為 Y 或 N',
        'E74000' => '付款人地址旗標格式必須為 Y 或 N',
        'E75000' => '收貨人姓名旗標格式必須為 Y 或 N',
        'E76000' => '收貨人行動電話旗標格式必須為 Y 或 N',
        'E77000' => '收貨人電子郵件旗標格式必須為 Y 或 N',
        'E78000' => '收貨人地址旗標格式必須為 Y 或 N',
        'E79000' => '退款原因不得超過 30 個中英文字，不可包含特殊字元',
        'E80000' => '收款服務帳戶未申請 API 服務',
        'E81000' => '伺服器內部發生錯誤',
        'E82000' => '呼叫外部服務發生錯誤',
        'E83000' => '已超過退款期限',
        'E84000' => '回傳路徑型態錯誤',
        'E84001' => '自訂參數一長度不得超過 255 中英文字，不可包含特殊字元',
        'E84002' => '自訂參數二長度不得超過 255 中英文字，不可包含特殊字元',
        'E84003' => '自訂參數三長度不得超過 255 中英文字，不可包含特殊字元',
        'E84004' => '不合法的自訂參數一旗標格式',
        'E84005' => '不合法的自訂參數二旗標格式',
        'E84006' => '不合法的自訂參數三旗標格式',
        'E84007' => '不合法的分期付款旗標格式',
        'E84008' => '不合法的紅利折抵旗標格式',
        'E85000' => '購物清單顯示設定值錯誤',
        'E86000' => '購物途徑長度不可超過 10 個字，不可包含特殊字元',
        'E87000' => '訂單狀態不符',
        'E88000' => '該筆訂單的收款方式無法使用該服務',
        'S00000' => '處理成功',
        'S00001' => '處理成功，查無資料或是查詢條件組合不相符',
    ];

    /**
     * @param string $message
     */
    public function __construct(string $message = '')
    {
        $this->message = $this->mappingMessage($message);
    }

    /**
     * @param  string $message
     * @return string|LogicException
     */
    protected function mappingMessage(string $message): string
    {
        if (!array_key_exists($message, $this->map)) {
            throw new LogicException('Unmapping message code fron sinopac.');
        }

        return $this->map[$message];
    }
}
